/**
 * Jaguar Serializer Library
 *
 * Contains API to create Serializers.
 *
 * - [Serializer]
 * - [GenSerializer]
 * - [EncodeOnly]
 * - [DecodeOnly]
 * - [EnDecode]
 * - [Ignore]
 * - [FieldProcessor]
 * - [SerializerRepo]
 * - [JsonRepo]
 * - [YamlRepo]
 */
library jaguar_serializer;

export 'src/annotations/annotations.dart';
export 'src/codec/codec.dart';
export 'src/codec/json.dart';
export 'src/serializer/serializer.dart';
export 'src/serializer/field_processor.dart';
export 'package:jaguar_serializer/src/repo/repo.dart';
export 'src/serializer/utils.dart';
export 'src/serializer/serializer.dart';
export 'src/name_formatters/name_formatters.dart';
